//
//  TestData.swift
//  chart
//
//  Created by Michael Chartier on 4/1/20.
//  Copyright © 2020 Michael Chartier. All rights reserved.
//

import Foundation


var resultsSession = SessionData()
var frontResults = ResultData()
var rearResults = ResultData()

class SessionData
{
    struct SensorSample
    {
        var time: Int       // Starts at zero when recording starts, increments by 1 for each data sample
        var gforce: Double    // -16 ... +16
        var frontAxle: Double    // 0mm ... maxAxleTravel
        var rearAxle: Double    // 0mm ... maxAxleTraval
        var rearSensor: Double    // 0mm ... maxShockTravel
    }

    let sampleRate = 200.0
    
    var sensorData = [SensorSample]()
    
    func loadFile( name: String )
    {
        if let filePath = Bundle.main.url(forResource: name, withExtension: "csv") {
            do {
                let data = try String(contentsOf: filePath, encoding: .utf8)
                let lines = data.components(separatedBy: .newlines)
                
                for line in lines
                {
                    let tokens = line.components(separatedBy: ",")
                    if let time = Int(tokens[0]), let gforce = Double(tokens[1]),
                        let front = Double(tokens[2]), let rear = Double(tokens[3]), let raw = Double(tokens[4]) {
                        let newSample = SensorSample(time: time, gforce: gforce, frontAxle: front, rearAxle: rear, rearSensor: raw)
                        sensorData.append(newSample)
                    }
                }
            } catch {
                print("ERROR")
            }
        }
    }
    
}

class ResultData
{
    struct AxleData { var position: Double; var valid: Bool }
    var axleData = [AxleData]()

    func loadData()
    {
        for item in resultsSession.sensorData {
            let newData = AxleData(position: item.frontAxle, valid: false)
            axleData.append(newData)
        }
    }
}

